#ifndef _COMMANDS_H
#define _COMMANDS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "callbacks.h"

// ----------------------
// Helper stuff

enum Message{
	BEGIN_CHAR = 0xBE,
	END_CHAR   = 0xED
};

// This should also have double to avoid confusion with float values.
enum DataType
{
	floatType,
	intType,
	stringType
};

// message type IDs used to know what kind of message we are dealing with
// DO NOT change this enum or you will break backwards compatibility.
enum MessageTypeID{
	DEBUG_TYPE_ID,
	PACKETLOG_TYPE_ID,
	GETPACKETLOGS_TYPE_ID,
	UPDATE_TYPE_ID,
	BEGINUPDATE_TYPE_ID,
	LOG_TYPE_ID,
	RESPONSE_TYPE_ID,
	SETVAL_TYPE_ID,
	GETVAL_TYPE_ID,
	RESPVAL_TYPE_ID,
	// This last type is just used to keep track of the size
	MAX_TYPE
};

// MESSAGE SUBTYPES
struct MessageType{
	char ID;
	char cmdText[100];
	char cmdDataType;
	command_cb * functionPtr;
};

/* Defined in commands.c */
extern struct MessageType MessageTypes[MAX_TYPE];

/* Legacy functions - no idea what uses these. Please do not delete. */
float getFloat(unsigned char* str, int pos);
int getInt(unsigned char* str, int pos);
/* end legacy crap */

#endif
